#include "max7219.h"

char dg=8;

#define cs_set() CLEAR_BIT(GPIOA->ODR,GPIO_ODR_ODR4)
#define cs_reset() SET_BIT(GPIOA->ODR,GPIO_ODR_ODR4)

void Send_7219 (uint8_t rg, uint8_t dt)
{
	cs_set();
  //8 bit
  /*
  while(!(READ_BIT(SPI1->SR, SPI_SR_TXE) == (SPI_SR_TXE))) {}
  SPI1->DR = (uint16_t)rg;
  while(!(READ_BIT(SPI1->SR, SPI_SR_RXNE) == (SPI_SR_RXNE))) {}
  (void) SPI1->DR;
  while(!(READ_BIT(SPI1->SR, SPI_SR_TXE) == (SPI_SR_TXE))) {}
  SPI1->DR = (uint16_t)dt;
  while(!(READ_BIT(SPI1->SR, SPI_SR_RXNE) == (SPI_SR_RXNE))) {}
  (void) SPI1->DR;
  */
  //16  bit
  while(!(READ_BIT(SPI1->SR, SPI_SR_TXE) == (SPI_SR_TXE))) {}
  SPI1->DR = (uint16_t)rg << 8 | dt;
  while(!(READ_BIT(SPI1->SR, SPI_SR_RXNE) == (SPI_SR_RXNE))) {}
  (void) SPI1->DR;
	cs_reset();
}
//------------------------------------------------------
void Clear_7219 (void)
{
	uint8_t i=dg;
	do
	{
		Send_7219(i,0xF);//символ пустоты
	} while (--i);
}
//------------------------------------------------------
void Number_7219 (volatile long n)
{
	uint8_t ng=0;//переменная для минуса
	if(n<0)
	{
		ng=1;
		n*=-1;
	}
	uint8_t i=0;
	do
	{
		Send_7219(++i,n%10);//символ цифры
		n/=10;
	} while(n);
	if(ng)
	{
		Send_7219(i+1,0x0A);//символ -
	}
}
//-------------------------------------------------------
void NumberL_7219 (volatile int n) //пишем в левую тетраду
{
  uint8_t ng=0;//переменная для минуса
  if(n<0)
  {
    ng=1;
    n*=-1;
  }
  uint8_t i=4;
  if(n<1000) Send_7219(8,0xF);//символ пустоты
  if(n<100) Send_7219(7,0xF);//символ пустоты
  if(n<10) Send_7219(6,0xF);//символ пустоты
  do
  {
    Send_7219(++i,n%10);//символ цифры
    n/=10;
  } while(n);
  if(ng)
  {
    Send_7219(i+1,0x0A);//символ -
  }
}
//-------------------------------------------------------
void NumberR_7219 (volatile int n)
{
	uint8_t ng=0;//переменная для минуса
	if(n<0)
	{
		ng=1;
		n*=-1;
	}
	uint8_t i=0;
  if(n<1000) Send_7219(4,0xF);//символ пустоты
  if(n<100) Send_7219(3,0xF);//символ пустоты
  if(n<10) Send_7219(2,0xF);//символ пустоты
	do
	{
		Send_7219(++i,n%10);//символ цифры
		n/=10;
	} while(n);
	if(ng)
	{
		Send_7219(i+1,0x0A);//символ -
	}
}
//-------------------------------------------------------
void NumberF_7219 (float f) //пишем в левую тетраду c десятичной цифрой
{
  int n = (int)(f * 10);
  uint8_t ng=0;//переменная для минуса
  if(n<0)
  {
    ng=1;
    n*=-1;
  }
  int m = n;
  uint8_t i=0;
  do
  {
    if(i==1) Send_7219(++i,(n%10) | 0x80);//символ цифры и точка
    else Send_7219(++i,n%10);//символ цифры
    n/=10;
  } while(n);
  if(ng)
  {
    if(m<10)
    {
      Send_7219(i+1,0x80);//ноль с точкой
      Send_7219(i+2,0x0A);//символ -
    }
    else Send_7219(i+1,0x0A);//символ -
  }
  else
  {
    if((m<10)&&(m!=0))
    {
      Send_7219(i+1,0x80);//ноль с точкой
    }
  }
}
//-------------------------------------------------------
void NumberLF_7219 (float f) //пишем в левую тетраду c десятичной цифрой
{
  int n = (int)(f * 10);
  uint8_t ng=0;//переменная для минуса
  if(n<0)
  {
    ng=1;
    n*=-1;
  }
  int m = n;
  uint8_t i=4;
  do
  {
    if(i==5) Send_7219(++i,(n%10) | 0x80);//символ цифры и точка
    else Send_7219(++i,n%10);//символ цифры
    n/=10;
  } while(n);
  if(ng)
  {
    if(m<10)
    {
      Send_7219(i+1,0x80);//ноль с точкой
      Send_7219(i+2,0x0A);//символ -
    }
    else Send_7219(i+1,0x0A);//символ -
  }
  else
  {
    if((m<10)&&(m!=0))
    {
      Send_7219(i+1,0x80);//ноль с точкой
    }
  }
}
//-------------------------------------------------------
void Init_7219 (void)
{
  Send_7219(0x0F,0x00);//отключим режим тестирования
  Send_7219(0x09,0xFF);//включим режим декодирования
  Send_7219(0x0B,dg-1);//кол-во используемых разрядов
  Send_7219(0x0A,0x06);//интенсивность свечения
  Send_7219(0x0C,0x01);//включим индикатор
  Clear_7219();
}
